%define _requires_exceptions  devel(libdb-4.8(64bit))

%define apache_version 2.2.0
%define libsvn %mklibname svn 0

# Java requires devel symlinks in non-devel packages due to design
# (System.loadLibrary). Do not add -devel dependencies.
%define _exclude_files_from_autoreq ^%_libdir/libsvnjavahl-%{svnjavahl_api}.so$

%define build_python 1
%{?_without_python: %{expand: %%global build_python 0}}

%define build_ruby 0
%{?_without_ruby: %{expand: %%global build_ruby 0}}

%define build_java 0
%{?_with_java: %{expand: %%global build_java 1}}

%define build_perl 1
%{?_without_perl: %{expand: %%global build_perl 0}}

%define build_test 0
%{?_with_test: %{expand: %%global build_test 1}}

%define with_debug 0
%{?_with_debug: %{expand: %%global with_debug 1}}

%define py_purelibdir %{py_libdir}
%define py_platlibdir %{py_libdir}
%define py_platsitedir %{py_sitedir}

Name: subversion
Version: 1.8.10
Release: %mkrel 6
Summary: A Concurrent Versioning System
Summary(de): Ein simultanes Versionierungssystem. 
License: BSD CC2.0
Group: Development/Other
URL: http://subversion.tigris.org
Source0: http://subversion.tigris.org/tarballs/%name-%version.tar.xz
Source1: %name.png
Source2: %mod_dav_conf
Source3: %mod_authz_conf
Source4: %name.bash-completion
Source5: %name-1.3.0-global-config
Source6: %name-1.3.0-global-servers
Source7: http://svnbook.red-bean.com/nightly/en/svn-book-html-chunk.tar.bz2
Patch0: subversion-1.8.3-underlink.diff
Patch4: subversion-hook-script_pathfix.diff
Patch5: subversion-propchange-email.diff
Patch6: subversion-1.5.5-format_not_a_string_literal_and_no_format_arguments.diff
BuildRequires:	autoconf >= 2.54
BuildRequires:	libtool >= 1.4.2
BuildRequires:	chrpath
BuildRequires:	python >= 2.2
BuildRequires:	texinfo
BuildRequires:	info-install
BuildRequires:	apache-devel >=  %{apache_version}
BuildRequires:	apr-devel
BuildRequires:	apr-util-devel
# contained in the package xsltproc
BuildRequires:	libxslt-proc  
BuildRequires:	docbook-style-xsl
BuildRequires:	serf-devel >= 1.2.1
BuildRequires:	sqlite3-devel >= 3.4.0
BuildRequires:	swig >= 1.3.27
BuildRequires:	multiarch-utils >= 1.0.3
Provides: %name-ra-method = %version-%{release}
Provides: %name-client-tools = %version-%{release}
Provides: svn = %{version}
Requires: %{libsvn} = %{version}
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-buildroot
Obsoletes:	apache-mod_dontdothat

%description
Subversion (SVN) is a concurrent version control system which enables one or
more users to collaborate in developing and maintaining a hierarchy of files
and directories while keeping a history of all changes.  Subversion only stores
the differences between versions, instead of every complete file.  Subversion
also keeps a log of who, when, and why changes occured.

As such it basically does the same thing CVS does (Concurrent Versioning
System) but has major enhancements compared to CVS and fixes a lot of the
annoyances that CVS users face.

This package contains the client, if you're looking for the server end
of things you want %name-repos. 

%description -l de
Subversion ist ein versionsvergleichendes Steuersystem, das zur Zusammenarbeit von 
einem oder mehreren Benutzern zur Aufrechterhaltung der Hirarchie von Dateien und 
Verzeichnissen, unter Beibehaltung eines Verlaufes über die Änderungen entwickelt 
wurde. Subversion speichert nur die Unterschiede zwischen den Versionen, anstatt 
jede vollständige Datei. Subversion erstellt auch ein Protokoll, wer, wann und 
warum Änderungen vorgenommen wurden. Im Grunde genommen macht es das selbe wie CVS 
(Concurrent Versions System), jedoch hat es wichtige Verbesserungen im Vergleich zu 
CVS und behebt viel nerviges, mit denen CVS Benutzer sich konfrontiert sehen. 

Dieses Paket enthält den Clienten, wenn Sie sich für Serveranwendungen 
interessieren benötigen sie Subversion-repos.

%files -f %name.lang
%defattr(-,root,root)
%_bindir/svn
%_bindir/svnversion
%_bindir/showchange*
%_bindir/svnlook
%_sysconfdir/bash_completion.d/%name
%_mandir/man1/svn.*
%_mandir/man1/svnlook.*
%_mandir/man1/svnversion.*
%_mandir/man1/svnsync.*
%dir %_datadir/subversion-%{version}
%if %mdkversion <= 910
    # Already included in vim-common on 9.2 and newer.
    %_datadir/vim/syntax/svn.vim
%endif


%package -n %libsvn
Summary: Subversion libraries
Summary(de): Subversion Bibliotheken
Group: System/Libraries

%description -n %libsvn
Subversion common libraries

%description -n %libsvn -l de
Übliche Subversionbibliotheken

#--------------------------------------------------------------------------

%files -n %libsvn
%defattr(-,root,root)
%_libdir/libsvn_ra-1.so.*
%_libdir/libsvn_ra_local-1.so.*
%_libdir/libsvn_ra_svn-1.so.*
%_libdir/libsvn_ra_serf-*.so.*
%_libdir/libsvn_client*so.*
%_libdir/libsvn_wc-*so.*
%_libdir/libsvn_delta-*so.*
%_libdir/libsvn_subr-*so.*
%_libdir/libsvn_diff-*so.*
%_libdir/libsvn_fs*.so.*
%_libdir/libsvn_repos-*.so.*
%config(noreplace) %_sysconfdir/subversion/*


#--------------------------------------------------------------------------

%package	doc
Summary:	Subversion Documenation
Summary(de):	Subversion Dokumentation
Group:		Documentation

%description	doc
Subversion is a concurrent version control system which enables
one or more users to collaborate in developing and maintaining a
hierarchy of files and directories while keeping a history of all
changes. Subversion only stores the differences between versions,
instead of every complete file. Subversion also keeps a log of
who, when, and why changes occured.

As such it basically does the same thing CVS does (Concurrent
Versioning System) but has major enhancements compared to CVS and
fixes a lot of the annoyances that CVS users face.

This package contains the subversion book and design info files.

%description	doc -l de
Subversion ist ein versionsvergleichendes Steuersystem, 
das zur Zusammenarbeit von einem oder mehreren Benutzern zur Aufrechterhaltung der 
Hirarchie von Dateien und Verzeichnissen, unter Beibehaltung eines Verlaufes über 
die Änderungen entwickelt wurde. Subversion speichert nur die Unterschiede zwischen 
den Versionen, anstatt jede vollständige Datei. Subversion erstellt auch ein 
Protokoll, wer, wann und warum Änderungen vorgenommen wurden. Im Grunde genommen 
macht es das selbe wie CVS (Concurrent Versions System), jedoch hat es wichtige 
Verbesserungen im Vergleich zu CVS und behebt viel nerviges, mit denen CVS Benutzer 
sich konfrontiert sehen. 

Dieses Paket enthält das Subversion Buch (englisch) und Info Dateien über das Design.

%post doc
%_install_info svn-design.info
%_install_info svn-handbook.info

%postun doc
%_install_info svn-design.info
%_install_info svn-handbook.info

%files doc
%defattr(0644,root,root,755)
%doc svnbook-1.*
%doc doc/user/*.html
%doc doc/user/*.txt

#--------------------------------------------------------------------------

%package	server
Summary:	Subversion Server
Summary(de):	Subversion Server
Group:		System/Servers
Requires: 	%name
Requires(pre):  rpm-helper
Requires(postun): rpm-helper
Requires(post): sed
Requires: %{libsvn}
BuildRoot: %{_tmppath}/%name-%version

%description server
This package contains a myriad of tools for subversion server
and repository admins:
  * hot-backup makes a backup of a svn repo without stopping
  * mirror_dir_through_svn.cgi 
  * various hook scripts
  * xslt example 

Note that cvs2svn has moved out of subversion and is a separate
project.  It has not released its own package yet, but you can
find it at http://cvs2svn.tigris.org/

%description server -l de
Dieses Paket enthält eine Unzahl an Servern für Subversion Server und Repository 
Administratoren:

   * hot-backup erstellt eine Sicherung der svn repo ohne Unterbrechung.
   * mirror_dir_through_svn.cgi
   * verschiedene hook Skripte
   * xslt Beispiele

Beachte, das cvs2svn aus subversion heraus genommen wurde und nun ein separates 
Projekt darstellt, es wurde noch kein eigenes Paket erstellt, aber du kannst es 
unter http://cvs2svn.tigris.org/ finden. 

%pre server
%_pre_useradd svn /var/lib/svn /bin/false

%post server
# Libraries for REPOS ( Repository ) and FS ( filesystem backends ) are in
# server now, so we need a ldconfig
/sbin/ldconfig
# fix svn entries in /etc/services
if ! grep -qE '^svn[[:space:]]+3690/(tcp|udp)[[:space:]]+svnserve' %{_sysconfdir}/services; then
	# cleanup
	sed -i -e '/^svn\(serve\)\?/d;/^# svnserve ports added by subversion-server/d' %{_sysconfdir}/services
	echo "# svnserve ports added by subversion-server" >> /etc/services
	echo -e "svn\t3690/tcp\tsvnserve\t# Subversion svnserve" >> /etc/services
	echo -e "svn\t3690/udp\tsvnserve\t# Subversion svnserve" >> /etc/services
fi

%postun server
%_postun_userdel svn
/sbin/ldconfig

%files server
%defattr(-,root,root)
%doc BUGS CHANGES COMMITTERS LICENSE INSTALL README
##%doc notes/repos_upgrade_HOWTO
%_bindir/svnserve
%config(noreplace) %_sysconfdir/xinetd.d/svnserve
%attr(0770,svn,svn) /var/lib/svn
%_mandir/man8/svnserve.8*
%_mandir/man5/svnserve.conf.5*

#--------------------------------------------------------------------------

%package tools
Summary:	Subversion Repo/Server Tools
Summary(de):	Subversion Repo-/Server-Werkzeuge
Group: Development/Other
Requires: %name
Conflicts: %name-server < 1.2.3-4
Obsoletes: %name-repo-tools < 1.2.3-4
Requires: %{libsvn}

%description tools
This package contains a myriad of tools for subversion server
and repository admins:
  * hot-backup makes a backup of a svn repo without stopping
  * mirror_dir_through_svn.cgi 
  * various hook scripts
  * xslt example 

Note that cvs2svn has moved out of subversion and is a separate
project.  It has not released its own package yet, but you can
find it at http://cvs2svn.tigris.org/

%description tools -l de
Dieses Paket enthält eine Unzahl an Servern für Subversion Server und Repository 
Administratoren:

   * hot-backup erstellt eine Sicherung der svn repo ohne Unterbrechung.
   * mirror_dir_through_svn.cgi
   * verschiedene hook Skripte
   * xslt Beispiele

Beachte, das cvs2svn aus subversion heraus genommen wurde und nun ein separates 
Projekt darstellt, es wurde noch kein eigenes Paket erstellt, aber du kannst es 
unter http://cvs2svn.tigris.org/ finden.

%files tools
%defattr(-,root,root)
%_bindir/hot-backup*
%_bindir/svnadmin
%_bindir/svnsync
%_bindir/svndumpfilter
%{_bindir}/svnrdump
%{_bindir}/svnmucc
%dir %_libexecdir/svn-tools
%_libexecdir/svn-tools/diff
%_libexecdir/svn-tools/diff3
%_libexecdir/svn-tools/diff4
%_libexecdir/svn-tools/fsfs-access-map
%_libexecdir/svn-tools/fsfs-reorg
%_libexecdir/svn-tools/fsfs-stats
%_libexecdir/svn-tools/svnauthz
%_libexecdir/svn-tools/svnauthz-validate
%_libexecdir/svn-tools/svn-bench
%_libexecdir/svn-tools/svnmucc
%_libexecdir/svn-tools/svn-populate-node-origins-index
%_libexecdir/svn-tools/svnraisetreeconflict
%_libexecdir/svn-tools/svn-rep-sharing-stats
%{_datadir}/%{name}-%{version}/repo-tools
%{_mandir}/man1/svnadmin.1*
%{_mandir}/man1/svndumpfilter.1*
%{_mandir}/man1/svnrdump.1*
%{_mandir}/man1/svnmucc.1*

#--------------------------------------------------------------------------

%if %{build_python}

%package -n	python-svn
Summary:	Python bindings for Subversion
Summary(de):	Pythonbindungen für Subversion
Group: Development/Other
Requires: python >= 2.7
Provides: python-subversion = %version-%{release}
Requires: %{libsvn}

%description -n python-svn
This package contains the files necessary to use the subversion
library functions within python scripts.

%description -n python-svn -l de
Diese Paket enthält die benötigten Dateien zur Verwendung der Subversion Bibliothek 
in Python Skripten.

%files -n python-svn
%defattr(0644,root,root,755)
%_libdir/libsvn_swig_py*.so.*
%{py_sitedir}/svn
%{py_platsitedir}/libsvn
%doc tools/examples/*.py subversion/bindings/swig/INSTALL subversion/bindings/swig/NOTES

%endif

#--------------------------------------------------------------------------

%if %{build_ruby}

%package -n	ruby-svn
Summary:	Ruby bindings for Subversion
Summary(de):	Rubybindungen für Subversion
Group: Development/Ruby
BuildRequires: ruby-devel
Requires: ruby
Requires: %{libsvn}
Provides: ruby-subversion = %version-%{release}

%description -n	ruby-svn
This package contains the files necessary to use the subversion
library functions within ruby scripts.

%description -n	ruby-svn -l de
Dieses Paket enthält die notwendigen Dateien zur Verwendung der Subversion Bibliotheken
innerhalb eines ruby Skriptes.

%files -n ruby-svn
%defattr(-,root,root)
%ruby_sitearchdir/svn
%ruby_sitelibdir/*/*.rb
%_libdir/libsvn_swig_ruby*.so.*

%endif

#--------------------------------------------------------------------------

%if %{build_java}
%define svnjavahl_api 1
%define libsvnjavahl %mklibname svnjavahl %{svnjavahl_api}

%package -n %{libsvnjavahl}
Summary: Svn Java bindings library
Group: System/Libraries
Conflicts: subversion-devel < 1.6.0-3
Obsoletes: %{_lib}svnjavahl0 < 1.6.0-3

%description -n %{libsvnjavahl}
Svn Java bindings library

%files -n %{libsvnjavahl}
%defattr(0644,root,root,0755)
%_libdir/libsvnjavahl-%{svnjavahl_api}.*


%package -n svn-javahl
Summary:	Java bindings for Subversion
Group:		Development/Java
Obsoletes:      java-svn < %{version}-%{release}
Provides:       java-svn = %{version}-%{release}
Provides:	java-subversion = %{version}-%{release}
Requires:	%{name}
Requires: 	%{libsvn}
Requires: 	%{libsvnjavahl}
BuildRequires:  java-devel
BuildRequires:  ant
%if %mdkversion >= 200810
BuildRequires:  java-rpmbuild >= 1.7.3-10
%else
BuildRequires:  jpackage-utils >= 1.7.3-10
%endif
BuildRequires:  junit

%description -n	svn-javahl
This package contains the files necessary to use the subversion
library functions from Java.

%files -n svn-javahl
%defattr(0644,root,root,0755)
%doc subversion/bindings/javahl/README
%{_javadir}/svn-javahl.jar
%{_javadir}/svn-javahl-%{version}.jar

%endif

#--------------------------------------------------------------------------

%if %{build_perl}

%package -n perl-SVN
Summary:	Perl bindings for Subversion
Summary(de):	Perlbindungen für Subversion
Group:		Development/Perl
BuildRequires:  perl-devel
Requires:	%name
Obsoletes:	perl-svn
Provides:	perl-svn = %version-%{release}
Requires: 	%{libsvn}

%description -n perl-SVN
This package contains the files necessary to use the subversion
library functions within perl scripts.

%description -n perl-SVN -l de
Dieses Paket enthält die notwendigen Dateien zur Verwendung der 
Subversion Bibliotheksfunktionen in Perl-Skripten.

%files -n perl-SVN
%defattr(-,root,root)
%doc subversion/bindings/swig/INSTALL subversion/bindings/swig/NOTES
%_libdir/libsvn_swig_perl*.so.*
%{perl_vendorarch}/SVN
%{perl_vendorarch}/auto/SVN
%{perl_sitearch}/*
%_mandir/man3/SVN::*.3*

%endif

#----------------------------------------------------------------

%package devel
Summary: Subversion headers/libraries for development
Summary(de): Subversion Header/Bibliotheken für die Entwicklung
Group: Development/Libraries
Provides: libsvn-devel = %version-%{release}
Obsoletes: libsubversion1_0-devel < 1.2.3-4
Obsoletes: libsubversion1_0-static-devel < 1.2.3-4
%if %{build_perl}
Requires: perl-SVN
Obsoletes: perl-SVN-devel < 1.5.2-2
Provides: per-SVN-devel = %{version}
%endif
%if %{build_perl}
Requires: python-svn
Obsoletes: python-svn-devel < 1.5.2-2
Provides: python-svn-devel = %{version}
%endif
%if %{build_ruby}
Requires: ruby-svn
Obsoletes: ruby-svn-devel < 1.5.2-2
Provides: ruby-svn-devel = %{version}
%endif
Requires: %libsvn


%description devel
This package contains the header files and linker scripts for
subversion libraries.

%description devel -l de
Dieses Paket enthält die Headerdateien und Linker-Skripte 
für die Subversion Bibliotheken

%files devel
%defattr(-,root,root)
%doc tools/examples/minimal_client.c
###%_libdir/libsvn*.la
%_includedir/subversion*/*
%_libdir/libsvn*.so
%if %{build_java}
%exclude %_libdir/libsvnjavahl*
%endif


#----------------------------------------------------------------

%define mod_version  %{apache_version}_%version
%define mod_dav_name mod_dav_svn
%define mod_dav_conf 46_%{mod_dav_name}.conf
%define mod_dav_so %{mod_dav_name}.so
%define mod_authz_name mod_authz_svn
%define mod_authz_conf 47_%{mod_authz_name}.conf
%define mod_authz_so %{mod_authz_name}.so

%package -n	apache-mod_dav_svn
Summary:	Subversion server DSO module for apache
Summary(de):	Subversion Server Modul DSO für Apache.
Group:		System/Servers
Requires: 	%name-tools
Requires(pre): rpm-helper
Requires(postun): rpm-helper
Requires(pre):	apache-conf >= %{apache_version}
Requires(pre):	apache >= %{apache_version}
Requires(pre):	apache-mod_dav >= %{apache_version}
Requires(pre): %{libsvn}

%description -n apache-mod_dav_svn
Subversion is a concurrent version control system which enables
one or more users to collaborate in developing and maintaining a
hierarchy of files and directories while keeping a history of all
changes. Subversion only stores the differences between versions,
instead of every complete file. Subversion also keeps a log of
who, when, and why changes occured.

As such it basically does the same thing CVS does (Concurrent
Versioning System) but has major enhancements compared to CVS and
fixes a lot of the annoyances that CVS users face.

This package contains the apache server extension DSO for running
a subversion server.

%description -n apache-mod_dav_svn -l de
Subversion ist ein gleichzeitiges Versions Steuerungssystem das es einem oder 
mehreren Benutzern ermöglicht bei der Entwicklung und Wartung einer Hierarchie von 
Dateien und Verzeichnissen unter Beibehaltung eines Verlaufs aller Änderungen 
zusammenzuarbeiten. Subversion speichert nur die Unterschiede zwischen den 
Versionen, statt jede vollständige Datei. Subversion schreibt auch ein Protokoll, 
Wer, wann und warum Änderungen gemacht wurden. Wenn es auch grundsätzlich dasselbe 
wie CVS macht (gleichzeitige Systemversionen erfassen) besitzt es aber im Vergleich 
zu CVS wichtige Verbesserungen und behebt viele lästige Dinge denen die CVS 
Benutzer ausgesetzt sind. 

Dieses Paket enthält die Apache Server Erweiterung DSO zum Betrieb eines 
Subversion Servers. 


%post -n apache-mod_dav_svn
if [ -f %{_var}/lock/subsys/httpd ]; then
    %{_initrddir}/httpd restart 1>&2;
fi

%postun -n apache-mod_dav_svn
if [ "$1" = "0" ]; then
    if [ -f %{_var}/lock/subsys/httpd ]; then
	%{_initrddir}/httpd restart 1>&2
    fi
fi

%files -n apache-mod_dav_svn
%defattr(-,root,root)
%doc subversion/%{mod_authz_name}/INSTALL
%attr(0644,root,root) %config(noreplace) %_sysconfdir/httpd/modules.d/%{mod_dav_conf}
%attr(0644,root,root) %config(noreplace) %_sysconfdir/httpd/modules.d/%{mod_authz_conf}
%attr(0755,root,root) %_libdir/apache-extramodules/%{mod_dav_so}
%attr(0755,root,root) %_libdir/apache-extramodules/%{mod_authz_so}
%attr(0644,root,root) %{_var}/www/icons/subversion.png
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/httpd/conf/dontdothat.conf
%attr(0755,root,root) %{_libdir}/apache-extramodules/mod_dontdothat.so


#%files -n apache-mod_dontdothat
#%defattr(-,root,root)
#%doc contrib/server-side/mod_dontdothat/README
#%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/httpd/modules.d/48_mod_dontdothat.conf
#%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/httpd/conf/dontdothat.conf

#--------------------------------------------------------------------------

%prep
%setup -q -a 7
%patch0 -p1 -b .underlink
#%patch4 -p0 -b .hook-script_pathfix
# it was removed after 1.3.2 but still referenced in subversion/libsvn_repos/repos.c
#%patch5 -p1 -b .propchange-email
#%patch6 -p1 -b .format_not_a_string_literal_and_no_format_arguments

###rm -rf neon apr apr-util db4

# fix shellbang lines, #111498
perl -pi -e 's|/usr/bin/env perl|%{_bindir}/perl|g' tools/hook-scripts/*.pl.in

# fix file perms
chmod 644 BUGS CHANGES COMMITTERS LICENSE INSTALL README

# move latest svnbook snapshot as their target version
mv svn-book-html-chunk svnbook-1.8

# lib64 fixes
perl -pi -e "s|\\$serf_prefix/lib\b|\\$serf_prefix/%{_lib}|g" build/ac-macros/serf.m4 configure*

%build
%serverbuild

%if %{build_java}
export JAVADIR=%{_jvmdir}/java
%endif

%define _disable_ld_no_undefined 1

%if %{build_ruby}
# override weird -shrext from ruby
export svn_cv_ruby_link="%{__cc} -shared"
export svn_cv_ruby_sitedir_libsuffix=""
export svn_cv_ruby_sitedir_archsuffix=""
%endif

%configure2_5x \
   --prefix=%{_prefix} \
   --sysconfdir=%_sysconfdir \
   --datadir=%_datadir \
   --libdir=%_libdir \
   --localstatedir=/var/lib \
   --mandir=%_mandir \
   --with-apr_memcache=%{_prefix} \
   --with-apxs=%{_sbindir}/apxs \
   --with-apache-libexecdir=%{_libdir}/apache-extramodules \
   --with-apr=%{_bindir}/apr-1-config \
   --with-apr-util=%{_bindir}/apu-1-config \
   --disable-mod-activation \
   --with-swig=%{_prefix} \
   --disable-static \
%if %{with_debug}
   --enable-maintainer-mode \
   --enable-debug \
%endif
%if %{build_java}
   --with-jdk=%{java_home} \
   --with-junit=%{_javadir}/junit.jar \
%endif
   --enable-shared \
   --with-serf=%{_prefix} \
   --disable-neon-version-check \
   --with-sqlite=%{_prefix}

   %if %{build_ruby}
# fix weird broken autopoo
perl -pi -e "s|^SWIG_RB_SITE_ARCH_DIR.*|SWIG_RB_SITE_ARCH_DIR=\"%ruby_sitearchdir\"|g" Makefile
perl -pi -e "s|^SWIG_RB_SITE_LIB_DIR.*|SWIG_RB_SITE_LIB_DIR=\"%ruby_sitelibdir\"|g" Makefile
%endif

# fix weird broken autopoo
perl -pi -e "s|^toolsdir.*|toolsdir=%_libexecdir/svn-tools|g" Makefile

%{make} all

%if %{build_python}
make swig-py swig_pydir=%{py_platsitedir}/libsvn swig_pydir_extra=%{py_sitedir}/svn
%endif

%if %{build_perl}
make swig-pl
pushd  subversion/bindings/swig/perl/native
	perl Makefile.PL
popd
%endif

%if %{build_ruby}
make swig-rb
%endif

%if %{build_java}
make javahl
%endif

# compile the extra module as well...
###%{_sbindir}/apxs -c -Isubversion/include -Isubversion \
#    contrib/server-side/mod_dontdothat/mod_dontdothat.c \
#    subversion/libsvn_subr/libsvn_subr-1.la

%if %{build_test}
echo "###########################################################################"
echo "This can take quite some time to finish, so please be patient..."
echo "Don't be too surprised it the tests takes 30 minutes on a dual xeon machine..."
make LC_ALL=C LANG=C LD_LIBRARY_PATH="`pwd`/subversion/bindings/swig/perl/libsvn_swig_perl/.libs:`pwd`/subversion/bindings/swig/python/libsvn_swig_py/.libs:\
`pwd`/subversion/bindings/swig/python/.libs:`pwd`/subversion/libsvn_ra_local/.libs:`pwd`/subversion/svnadmin/.libs:\
`pwd`/subversion/tests/libsvn_ra_local/.libs:`pwd`/subversion/tests/libsvn_fs/.libs:`pwd`/subversion/tests/libsvn_wc/.libs:\
`pwd`/subversion/tests/libsvn_fs_base/.libs:`pwd`/subversion/tests/libsvn_diff/.libs:`pwd`/subversion/tests/libsvn_subr/.libs:\
`pwd`/subversion/tests/libsvn_delta/.libs:`pwd`/subversion/tests/libsvn_repos/.libs:`pwd`/subversion/tests/.libs:\
`pwd`/subversion/svnserve/.libs:`pwd`/subversion/libsvn_fs/.libs:`pwd`/subversion/libsvn_ra/.libs:`pwd`/subversion/libsvn_wc/.libs:\
`pwd`/subversion/mod_dav_svn/.libs:`pwd`/subversion/mod_authz_svn/.libs:`pwd`/subversion/svnlook/.libs:`pwd`/subversion/svndumpfilter/.libs:\
`pwd`/subversion/libsvn_client/.libs:`pwd`/subversion/libsvn_fs_base/bdb/.libs:`pwd`/subversion/libsvn_fs_base/util/.libs:\
`pwd`/subversion/libsvn_fs_base/.libs:`pwd`/subversion/libsvn_diff/.libs:`pwd`/subversion/libsvn_subr/.libs:`pwd`/subversion/svnversion/.libs:\
`pwd`/subversion/libsvn_ra_dav/.libs:`pwd`/subversion/libsvn_ra_svn/.libs:`pwd`/subversion/libsvn_delta/.libs:`pwd`/subversion/libsvn_fs_fs/.libs:\
`pwd`/subversion/libsvn_repos/.libs:`pwd`/subversion/clients/cmdline/.libs:$LD_LIBRARY_PATH" check
%endif

    
%install
###PV rm -rf %buildroot

%makeinstall_std

%if %{build_python}
%makeinstall_std install-swig-py swig_pydir=%{py_platsitedir}/libsvn swig_pydir_extra=%{py_sitedir}/svn
# Precompile python 
%py_compile %buildroot/%{py_platsitedir}/libsvn
%py_compile %buildroot/%{py_sitedir}/svn
%endif

%if %{build_perl}
%makeinstall_std install-swig-pl-lib
pushd subversion/bindings/swig/perl/native/
	perl Makefile.PL
	%makeinstall_std
popd
%endif

%if %{build_ruby}
%makeinstall_std install-swig-rb
%endif

%if %{build_java}
%{makeinstall_std} install-javahl
mkdir -p %{buildroot}%{_javadir}
%{__mv} %{buildroot}%{_libdir}/svn-javahl/svn-javahl.jar %{buildroot}%{_javadir}/svn-javahl-%{version}.jar
%{__ln_s} svn-javahl-%{version}.jar %{buildroot}%{_javadir}/svn-javahl.jar
%{_bindir}/chrpath -d %{buildroot}%{_libdir}/libsvnjavahl-1.so
%endif

%if %{build_perl}
# perl bindings
make pure_vendor_install -C subversion/bindings/swig/perl/native DESTDIR=%buildroot
%endif

install -d %buildroot%_sysconfdir/httpd/modules.d
cat %{SOURCE2} > %buildroot%_sysconfdir/httpd/modules.d/%{mod_dav_conf}
cat %{SOURCE3} > %buildroot%_sysconfdir/httpd/modules.d/%{mod_authz_conf}

# install the extra module
%makeinstall_std install-tools

# cleanup
rm -f %{buildroot}%{_libdir}/apache-extramodules/*.*a

# cat > %{buildroot}%{_sysconfdir}/httpd/modules.d/48_mod_dontdothat.conf << EOF
# <IfDefine HAVE_DONTDOTHAT>
#     <IfModule !mod_dontdothat.c>
# 	LoadModule dontdothat_module    extramodules/mod_dontdothat.so
#     </IfModule>
# </IfDefine>
# 
# <IfModule mod_dontdothat.c>
# 
#     <Location /svn>
#         DAV svn
#         SVNParentPath /var/lib/svn/repositories
#         DontDoThatConfigFile %{_sysconfdir}/httpd/conf/dontdothat.conf
#     </Location>
# 
# </IfModule>
# EOF


install -d %{buildroot}%{_sysconfdir}/httpd/conf
cat > %{buildroot}%{_sysconfdir}/httpd/conf/dontdothat.conf << EOF
[recursive-actions]
/*/trunk = allow
/ = deny
/* = deny
/*/tags = deny
/*/branches = deny
/*/* = deny
/*/*/tags = deny
/*/*/branches = deny
EOF

######################
###  client-tools  ###
######################

# vim syntax hilighting
%if %mdkversion <= 910
    # Already included in vim-common on 9.2 and newer.
    install -d -m 755 %buildroot/%_datadir/vim/syntax
    install -m 644 contrib/client-side/svn.vim %buildroot/%_datadir/vim/syntax
%endif

# various commands
# contrib was removed in subversion-1.7.x :
#  -- http://subversion.apache.org/docs/release-notes/1.7.html
#  -- (shlomif)
# install -m 755 contrib/client-side/search-svnlog.pl %buildroot%_bindir
# (cd  %buildroot/%_bindir; ln -sf  search-svnlog.pl search-svnlog)
# install -m 755 contrib/client-side/svn_all_diffs.pl %buildroot%_bindir
# (cd  %buildroot/%_bindir; ln -sf  svn_all_diffs.pl svn_all_diffs)
# install -m 755 contrib/client-side/svn_load_dirs/svn_load_dirs.pl %buildroot%_bindir
# (cd  %buildroot/%_bindir; ln -sf  svn_load_dirs.pl svn_load_dirs)
# install -m 755 contrib/client-side/svn-log.pl %buildroot%_bindir
# (cd  %buildroot/%_bindir; ln -sf  svn-log.pl svn-log)

install -m 755 tools/client-side/showchange.pl %buildroot%_bindir
(cd  %buildroot/%_bindir; ln -sf  showchange.pl showchange)

# bash completion
install -d -m 755 %buildroot%_sysconfdir/bash_completion.d
install -m 644 %SOURCE4 %buildroot%_sysconfdir/bash_completion.d/%name

# Global configs
install -d -m 755 %buildroot%_sysconfdir/subversion
install -m 644 %SOURCE5 %buildroot%_sysconfdir/subversion/config
install -m 644 %SOURCE6 %buildroot%_sysconfdir/subversion/servers

####################
###  repo-tools  ###
####################

# hotbackup tool
install -m 755 tools/backup/hot-backup.py %buildroot%_bindir
(cd %buildroot%_bindir; ln -sf  hot-backup.py hot-backup)

# hook-scripts
install -d -m755 %buildroot%_datadir/%name-%version/repo-tools/hook-scripts
pushd tools/hook-scripts
install -m 644 commit-access-control.cfg.example %buildroot/%_datadir/%name-%version/repo-tools/hook-scripts
install -m 755 commit-access-control.pl %buildroot/%_datadir/%name-%version/repo-tools/hook-scripts
install -m 644 svnperms.conf.example %buildroot/%_datadir/%name-%version/repo-tools/hook-scripts
install -m 755 svnperms.py %buildroot/%_datadir/%name-%version/repo-tools/hook-scripts
install -m 755 mailer/mailer.py %buildroot/%_datadir/%name-%version/repo-tools/hook-scripts
install -m 644 mailer/mailer.conf.example %buildroot/%_datadir/%name-%version/repo-tools/hook-scripts
popd

pushd tools/hook-scripts
install -m 755 commit-email.rb %buildroot/%_datadir/%name-%version/repo-tools/hook-scripts
popd

#xslt
install -d -m755 %buildroot%_datadir/%name-%version/repo-tools/xslt
install -m 644 tools/xslt/svnindex.css %buildroot%_datadir/%name-%version/repo-tools/xslt
install -m 644 tools/xslt/svnindex.xsl %buildroot%_datadir/%name-%version/repo-tools/xslt

#cgi
# contrib was removed in subversion-1.7.x :
# install -d -m755 %buildroot%_datadir/%name-%version/repo-tools/cgi
# install -m 755 contrib/cgi/mirror_dir_through_svn.cgi %buildroot%_datadir/%name-%version/repo-tools/cgi
# install -m 644 contrib/cgi/mirror_dir_through_svn.README %buildroot%_datadir/%name-%version/repo-tools/cgi
# install -m 755 contrib/cgi/tweak-log.cgi %buildroot%_datadir/%name-%version/repo-tools/cgi

# install a nice icon for web usage
install -d %buildroot/var/www/icons
install -m644 %SOURCE1 %buildroot/var/www/icons/subversion.png

# fix a missing file...
ln -sf libsvn_diff-1.so.0.0.0 %buildroot%_libdir/libsvn_diff.so

%{_bindir}/chrpath -d %{buildroot}%{_bindir}/svn
%{_bindir}/chrpath -d %{buildroot}%{_bindir}/svnlook
%{_bindir}/chrpath -d %{buildroot}%{_bindir}/svnversion
%{_bindir}/chrpath -d %{buildroot}%{_bindir}/svnserve
%{_bindir}/chrpath -d %{buildroot}%{_bindir}/svnadmin
%{_bindir}/chrpath -d %{buildroot}%{_bindir}/svndumpfilter
%{_bindir}/chrpath -d %{buildroot}%{_bindir}/svnsync
%{_bindir}/chrpath -d %{buildroot}%{_bindir}/svnrdump

# fix the stupid rpath stuff...
myf() { find %{buildroot}%{perl_vendorarch} -type f -name "*.so"; }
# Fix the readonly permissions of the perl files.
myf | xargs chmod u+w
myf | xargs chrpath -d

# handle translations
%find_lang %name

# fix the server parts
install -d %buildroot%_sysconfdir/xinetd.d
cat > svnserve.xinetd << EOF
# default: off
# description: svnserve is the server part of Subversion.
service svnserve
{
    disable		= yes
    port		= 3690
    socket_type		= stream
    protocol		= tcp
    wait		= no
    user		= svn
    server		= %_bindir/svnserve
    server_args		= -i -r /var/lib/svn/repositories
}
EOF
install -m 644 svnserve.xinetd %buildroot%_sysconfdir/xinetd.d/svnserve
install -d %buildroot/var/lib/svn/repositories

# Move perl man
chmod u+w %{buildroot}%_prefix/local/share/man/man3/*
mv %buildroot%_prefix/local/share/man/man3/* %buildroot%_mandir/man3/

# cleanup
find %buildroot -name "perllocal.pod" | xargs rm -f

# delete all .la files
find %{buildroot} -name *.la -delete

#not packaged at the moment
rm -f %{buildroot}/%{_libdir}/libsvn_auth_gnome_keyring-1.so*

chmod 0755 %buildroot/usr/lib/perl5/site_perl/5.22.3/x86_64-linux-thread-multi/auto/SVN/*/*.so

%clean
rm -rf %buildroot


%changelog
* Thu Jan 31 2019 tex - 1.8.10-6pclos2019
- dont build ruby

* Thu Jan 31 2019 tex - 1.8.10-5pclos2019
- rebuild against updates

* Mon Jan 27 2019 tex 1.8.10-4pclos2019
- rebuild db53-devel

* Thu Jul 13 2017 bb2 <bb2> - 1.8.10-3pclos2017
- rebuild against updates

* Mon Nov 03 2014 bb <bb> 1.8.10-2pclos2014
- rebuild new ruby

* Fri Aug 15 2014 bb <bb> 1.8.10-1pclos2014
- update

* Wed Jan 29 2014 pinoc <vogtpet at gmail.com> 1.8.5-1pclos2014
- 1.8.5
- obsolete deleted subpackage apache-mod_dontdothat
- remove la-files
- remove neon-stuff, not needed

* Tue Aug 20 2013 billybot <billybot> 1.6.20-1pclos2013
- update python 2.7

